<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Teknisa\MAN\Services\ParaMensagemKDS as ParaMensagemService;
use Teknisa\MAN\Services\FileUploaderService;
use Teknisa\MAN\Services\NovoCodigo;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;

class ParaMensagemKDS extends Crud {
   
   const dataSourceArquivos = 'selectArquivos',
         dataSourceDefault  = 'paraMensagensKDS'; 
   
   protected $dataSourceName = self::dataSourceDefault;
   
   protected $service;
   protected $fileUploaderService;
   protected $novoCodigo;
   protected $conn;
   
    public function __construct (Manager $manager, ParaMensagemService $service, FileUploaderService $fileUploaderService, NovoCodigo $novoCodigo, $conn) {
        parent::__construct($manager);
        $this->service = $service;
        $this->fileUploaderService = $fileUploaderService; 
        $this->novoCodigo = $novoCodigo;  
        $this->conn = $conn; 
    }
   
    public function save (DTO\Request\DataSet $request, DTO\Response $response) {
        $rows = $request->getDataSet()->getRows();
        
        if(count($rows) === 1) {
            $row = $rows[0];
            $bool = $row['__is_new'];
            
            if($bool) {
                $request = $this->service->newRequest($request);
            }
            
            $newResponse = new DTO\Response();
            
            if(isset($row['SOMBEEP']) && !!$row['SOMBEEP'] && !is_string($row['SOMBEEP']) && count($row['SOMBEEP']) > 0 ) {
                $row->set('__is_new', true);
                $row->set('IDATIVO', 'S');
                
                foreach ($row['SOMBEEP'] as $file) {
                    $row->set('NMARQUIVO', $file['name']);
                    $row->set('TPARQUIVO', $file['type']);
                     
                    $base64withMIMEDivided = explode(",", $file['b64File']);
                    $base64 = $base64withMIMEDivided[1];
                    $row->set('ARQUIVO', $base64);
                    
                    $row->set('CDARQUIVO', str_pad($this->novoCodigo->geraCodigo($this->conn, 'ARQUIVO', $row['NRORG']), 20, "0", STR_PAD_LEFT) );
                    $row->set('CDARQUIVOSOMMSG', $row['CDARQUIVO']);
                    
                    $this->dataSourceName = self::dataSourceArquivos;
                    parent::save($request, $newResponse);
                }
            }
            
            $row->set('__is_new', $bool);
            
            $this->dataSourceName = self::dataSourceDefault;
            parent::save($request, $response);
        }
    }
}